#property copyright "Copyright  2011, Murad Ismayilov"
#property link      "http://www.mql4.com/ru/users/wmlab"

#property indicator_chart_window
#property indicator_buffers 3

#property indicator_style1 STYLE_SOLID
#property indicator_width1 1
#property indicator_color1 Blue

#property indicator_style2 STYLE_SOLID
#property indicator_width2 1
#property indicator_color2 Red

#property indicator_style3 STYLE_SOLID
#property indicator_width3 1
#property indicator_color3 Silver

#include <stdlib.mqh>
#include <stderror.mqh>

#define DOUBLEMAX  1000000.0
#define DOUBLEMIN -1000000.0

//  

extern bool IsTopCorner = true; //     ?
extern int Offset = 1; //      (   ) [1..]
extern int PastBars = 8; //    ,     [3..]
extern int ForecastBars = 1; //       [1..]
extern int MaxAlts = 100; //   -   [1..100]
extern double MinSpearmanPercents = 90.0; //      
extern double SpearmanPercents = 5.0; //       
extern bool IsExactTime = true; //      (   )
extern datetime MinDate = D'01.01.2001'; //   
extern int PeriodMA = 2; //   
extern double ScalePercents = 90.0; //        
extern int XCorner = 5; //  .     
extern int YCorner = 5; //  .     
extern string FontName = "Arial"; //   .
extern int FontSize = 7; //    .
extern color TextColor = MediumBlue; //   .
extern color TextWarningColor = Tomato; //     .
extern color ArrowBuyColor = Blue; //   
extern color ArrowSellColor = Red; //   
extern color ArrowUnknownColor = Silver; //   

//  

string IndicatorName = "WmiFor";
string IndicatorVersion = "2.4";
string IndicatorAuthor = "  (wmlab@hotmail.com)";

double ForecastArrowBuy[];
double ForecastArrowSell[];
double ForecastArrowUnknown[];

//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+

int init()
{
   if (Offset < 1)
   {
      Offset = 1;
   }
   
   if (PastBars < 3)
   {
      PastBars = 3;
   }   
   
   if (ForecastBars < 1)
   {
      ForecastBars = 1;
   }

   if (MaxAlts < 1)
   {
      MaxAlts = 1;
   }
   else
   {
      if (MaxAlts > 100)
      {
         MaxAlts = 100;
      }
   }
   
   SetIndexBuffer(0, ForecastArrowBuy);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexShift(0, ForecastBars - Offset);
   
   SetIndexBuffer(1, ForecastArrowSell);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexShift(1, ForecastBars - Offset);
   
   SetIndexBuffer(2, ForecastArrowUnknown);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, 251);
   SetIndexShift(2, ForecastBars - Offset);
   
   LoadHistory(Period());
   RemoveOurObjects();
   
   return (0);
}

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+

int deinit()
{
   RemoveOurObjects();

   return (0);
}

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars = IndicatorCounted();
   
   //   ?
   
   if (IsNewBar())
   {
      ReCalculate();
   }
   
   return (0);
}

//+------------------------------------------------------------------+
//|   ?                                              |
//+------------------------------------------------------------------+

bool IsNewBar()
{
   static datetime prevTime = 0;

   datetime currentTime = iTime(NULL, 0, 0);
   if (prevTime == currentTime)
   {
      return (false);
   }

   prevTime = currentTime;
   return (true);
}

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+

void LoadHistory(int period = 0)
{
   int iPeriod[9];
   iPeriod[0] = PERIOD_M1;
   iPeriod[1] = PERIOD_M5;
   iPeriod[2] = PERIOD_M15;
   iPeriod[3] = PERIOD_M30;
   iPeriod[4] = PERIOD_H1;
   iPeriod[5] = PERIOD_H4;
   iPeriod[6] = PERIOD_D1;
   iPeriod[7] = PERIOD_W1;
   iPeriod[8] = PERIOD_MN1;
   for (int i = 0; i < 9; i++)
   {
      if ((period != 0) && (period != iPeriod[i]))
      {
         continue;
      }
   
      double open = iTime(Symbol(), iPeriod[i], 0);
      int error = GetLastError();
      while (error == ERR_HISTORY_WILL_UPDATED)
      {
         Sleep(10000);
         open = iTime(Symbol(), iPeriod[i], 0);
         error = GetLastError();
      }
   }
}

//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+

void RemoveOurObjects()
{
   for (int index = 0; index < ObjectsTotal(); index++)
   {
      if (StringFind(ObjectName(index), IndicatorName) == 0)
      {
         ObjectDelete(ObjectName(index));
         index--;
      }
   }
}

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+

void ReCalculate()
{
   if (Bars < 100)
   {
      return;
   }   
   
   int indexBar;
   double x[], xp[];
   double xcbase;
   double xhighest, xlowest;
   int foundAlts;
   double iAlt[], kAlt[], sAlt[], aAlt[];
   double y[], yp[];
   double yhighest, ylowest;
   double scale, scalep;
   double kspearman, kh, kl;
   int patternscount;
   int diffcount;
   bool altAdded;
   datetime ytime;
   
   int baseHour = TimeHour(iTime(NULL, 0, Offset));
   int baseMinute = TimeMinute(iTime(NULL, 0, Offset));
   
   //      

   ArrayResize(x, PastBars);
   xcbase = 0.0;
   for (indexBar = 0; indexBar < PastBars; indexBar++)
   {
      x[indexBar] = iMA(NULL, 0, PeriodMA, 0, MODE_LWMA, PRICE_CLOSE, indexBar + Offset);
      xcbase += x[indexBar];  
   }
   
   xcbase /= PastBars;
   xhighest = x[ArrayMaximum(x)];
   xlowest = x[ArrayMinimum(x)];   
   
   ArrayResize(xp, PastBars);
   SpearmenRange(x, xp);
   
   //     

   foundAlts = 0;
   patternscount = 0;
   ArrayResize(iAlt, MaxAlts);
   ArrayResize(kAlt, MaxAlts);
   ArrayResize(sAlt, MaxAlts);
   ArrayResize(aAlt, MaxAlts);

   //     
   
   for (int indexShift = ForecastBars + Offset + 1; indexShift < Bars; indexShift++)
   {
      ytime = iTime(NULL, 0, indexShift);
      if (IsExactTime)
      {
         //    
      
         int currentHour = TimeHour(ytime);
         if (currentHour != baseHour)
         {
            continue;
         }

         int currentMinute = TimeMinute(ytime);
         if (currentMinute != baseMinute)
         {
            continue;
         }
      }
      
      if ((indexShift + PastBars) >= Bars)
      {
         //     
      
         break;
      }
   
      if (ytime < MinDate)
      {
         //   
      
         break;
      }
      
      patternscount++;
      
      //      
      
      ArrayResize(y, PastBars);
      double av = 0.0;
      for (indexBar = 0; indexBar < PastBars; indexBar++)
      {
         y[indexBar] = iMA(NULL, 0, PeriodMA, 0, MODE_LWMA, PRICE_CLOSE, indexBar + indexShift);
         av += y[indexBar];
      }
      
      //   
      
      diffcount = 0;
      for (indexBar = 0; indexBar < (PastBars - 1); indexBar++)
      {
         if( 
            ((x[indexBar] < x[indexBar + 1]) && (y[indexBar] > y[indexBar + 1])) ||
            ((x[indexBar] > x[indexBar + 1]) && (y[indexBar] < y[indexBar + 1]))
           )
         {
            diffcount++;
            break;
         }
      }
      
      if (diffcount > 0)
      {
         continue;
      }
            
      av /= PastBars;
      yhighest = y[ArrayMaximum(y)];
      ylowest = y[ArrayMinimum(y)];
      
      ArrayResize(yp, PastBars);
      SpearmenRange(y, yp);
      
      // 
   
      scale = (xhighest - xlowest) / (yhighest - ylowest);
      if (scale > 1.0)
      {
         scalep = 100.0 / scale;
      }
      else
      {
         scalep = 100.0 * scale;
      }
      
      if (scalep < ScalePercents)
      {
         continue;
      }
      
      //  
      
      kspearman = SpearmenCorrelation(xp, yp);
      if (
         ((foundAlts == 0) && (kspearman < MinSpearmanPercents)) ||
         ((foundAlts > 0) && (kspearman < (kAlt[0] - SpearmanPercents)))
         )
      {
         continue;
      }
      
      //      
      
      altAdded = false;
      for (int j = 0; j < foundAlts; j++)
      {
         if (kspearman > kAlt[j])
         {
            if (foundAlts == MaxAlts)
            {
               foundAlts = MaxAlts - 1;   
            }
         
            for (int m = foundAlts; m >= (j + 1); m--)
            {
               kAlt[m] = kAlt[m - 1];
               iAlt[m] = iAlt[m - 1];
               sAlt[m] = sAlt[m - 1];
               aAlt[m] = aAlt[m - 1];
            }
         
            kAlt[j] = kspearman;
            iAlt[j] = indexShift;
            sAlt[j] = scale;
            aAlt[j] = av;
            foundAlts++;
            altAdded = true;
            
            break;
         }
      }
      
      if (!altAdded)
      {
         if (foundAlts < MaxAlts)
         {
            kAlt[j] = kspearman;
            iAlt[j] = indexShift;
            sAlt[j] = scale;
            foundAlts++;
         }
      }
   }
   
   //   
   
   if (foundAlts > 1)
   {
      for (int a = 1; a < foundAlts; a++)
      {
         if (kAlt[a] < (kAlt[0] - SpearmanPercents))
         {
            foundAlts = a;
            break;
         }
      }
   }
   
   //  
   
   ArrayInitialize(ForecastArrowBuy, EMPTY_VALUE);
   ArrayInitialize(ForecastArrowSell, EMPTY_VALUE);
   ArrayInitialize(ForecastArrowUnknown, EMPTY_VALUE);
   
   int sellcount;
   int alt, altindex;
   double votes;
   if (foundAlts > 1)
   {  
      SetIndexArrow(2, 253);
      for (indexBar = 0; indexBar < ForecastBars; indexBar++)
      {      
         sellcount = 0;
         for (alt = 0; alt < foundAlts; alt++)
         {
            altindex = iAlt[alt] - ForecastBars + indexBar;
            if (Open[altindex] > Close[altindex])
            {
               sellcount++;
            }
         }
         
         votes = (sellcount * 100.0) / foundAlts;
         if (votes >= 80.0)
         {
            ForecastArrowSell[indexBar] = x[0];
         }
         else
         {
            if (votes <= 20.0)
            {
               ForecastArrowBuy[indexBar] = x[0];
            }
            else
            {
               ForecastArrowUnknown[indexBar] = x[0];
            }
         }
      }
   }
   else
   {
      SetIndexArrow(2, 251);
      for (indexBar = 0; indexBar < ForecastBars; indexBar++)
      {
         ForecastArrowUnknown[indexBar] = x[0];
      }      
   }
   
   //   
   
   DrawLabel("Name", " " + IndicatorName + ",  " + IndicatorVersion, 0, 0, TextColor);
   DrawLabel("Author", IndicatorAuthor, 0, 10, TextColor);

   if (patternscount < 100)
   {
      DrawLabel("Alt1", ":   " + Symbol(), 0, 25, TextWarningColor);
   }
   else
   {
      DrawLabel("Alt1", "  : " + patternscount, 0, 25, TextColor);
   }
   
   if (foundAlts <= 1)
   {
      if (foundAlts == 0)
      {
         DrawLabel("Alt2", "   ", 0, 35, TextColor);
      }
      else
      {
         DrawLabel("Alt2", "   ", 0, 35, TextColor);   
      }
   }
   else
   {
      DrawLabel("Alt2", "  : " + foundAlts, 0, 35, TextColor);
   }
   
   int labely = 50;
   for (int label = 0; label < 5; label++)
   {
      if (label >= foundAlts)
      {
         DrawLabel("Found" + label, " ", 0, labely, TextColor);
      }
      else
      {
         altindex = iAlt[label];
         DrawLabel("Found" + label, TimeToStr(Time[altindex]) + " -  " + DoubleToStr(kAlt[label], 1) + "%", 0, labely, TextColor);   
      }
      
      labely += 10;
   }
}

//+------------------------------------------------------------------+
//|    C                                 |
//+------------------------------------------------------------------+

void SpearmenRange(double x[], double &xp[])
{   int xpi;
   int arraySize = ArraySize(x);
   double xlevelmin = DOUBLEMIN;
   for (int pass = 0; pass < arraySize; pass++)
   {
      int ixmin = -1;
      double xmin = DOUBLEMIN;
      for (int ix = 0; ix < arraySize; ix++)
      {
         if (x[ix] <= xlevelmin)
         {
            continue;
         }
      
         if (ixmin == -1)
         {
            ixmin = ix;
            xmin = x[ix];
         }
         else
         {
            if (x[ix] < xmin)
            {
               ixmin = ix;
               xmin = x[ix];
            }
         }
      }
      
      xpi++;
      xp[ixmin] = xpi;
      xlevelmin = xmin;
   }
}

//+------------------------------------------------------------------+
//|    C                                  |
//+------------------------------------------------------------------+

double SpearmenCorrelation(double xp[], double yp[])
{
   int arraySize = ArraySize(xp);
   double k = 0.0;
   for (int indexBar = 0; indexBar < arraySize; indexBar++)
   {
      k += (xp[indexBar] - yp[indexBar]) * (xp[indexBar] - yp[indexBar]);
   }
   
   k = (1.0 - ((6.0 * k) / ((arraySize * arraySize * arraySize) - arraySize))) * 100.0;
   return (k);
}

//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+

void DrawLabel(string label, string text, int x, int y, color clr)
{
   int typeCorner = 1;
   if (!IsTopCorner)
   {
      typeCorner = 3;
   }

   string labelIndicator = IndicatorName + "Label" + label;   
   if (ObjectFind(labelIndicator) == -1)
   {
      ObjectCreate(labelIndicator, OBJ_LABEL, 0, 0, 0);
   }
   
   ObjectSet(labelIndicator, OBJPROP_CORNER, typeCorner);
   ObjectSet(labelIndicator, OBJPROP_XDISTANCE, XCorner + x);
   ObjectSet(labelIndicator, OBJPROP_YDISTANCE, YCorner + y);
   ObjectSetText(labelIndicator, text, FontSize, FontName, clr);
}

